=== modified file 'bzrlib/tests/workingtree_implementations/test_workingtree.py'
--- bzrlib/tests/workingtree_implementations/test_workingtree.py	2006-04-11 01:34:08 +0000
+++ bzrlib/tests/workingtree_implementations/test_workingtree.py	2006-04-12 03:21:39 +0000
@@ -114,6 +114,17 @@
         self.check_file_contents('hello.txt.~1~', 'new hello')
         self.check_file_contents('hello.txt.~2~', 'new hello2')
 
+    def test_revert_missing(self):
+        # Revert a file that has been deleted since last commit
+        tree = self.make_branch_and_tree('.')
+        file('hello.txt', 'w').write('initial hello')
+        tree.add('hello.txt')
+        tree.commit('added hello.txt')
+        os.unlink('hello.txt')
+        tree.remove('hello.txt')
+        tree.revert(['hello.txt'])
+        self.failUnlessExists('hello.txt')
+
     def test_unknowns(self):
         tree = self.make_branch_and_tree('.')
         self.build_tree(['hello.txt',

=== modified file 'bzrlib/transform.py'
--- bzrlib/transform.py	2006-04-10 04:25:38 +0000
+++ bzrlib/transform.py	2006-04-12 03:01:32 +0000
@@ -981,14 +981,14 @@
     else:
         interesting_ids = set()
         for tree_path in filenames:
+            not_found = True
             for tree in (working_tree, target_tree):
-                not_found = True
                 file_id = tree.inventory.path2id(tree_path)
                 if file_id is not None:
                     interesting_ids.add(file_id)
                     not_found = False
-                if not_found:
-                    raise NotVersionedError(path=tree_path)
+            if not_found:
+                raise NotVersionedError(path=tree_path)
     return interesting_ids
 
 

